#include "m_pd.h"
#include<stdio.h>
#include<string.h>
#include<fcntl.h>
#include<limits.h>
#include<unistd.h>

static t_class *gpio_out_class;

typedef struct _gpio_out {
  t_object  x_obj;
  t_float input;
  int outlet;
  t_int out;
  char buf[1024];
  t_symbol *nom;
} t_gpio_out;

static void gpio_out_float(t_gpio_out *x, t_floatarg g)
{
  x->out = open(x->buf, O_WRONLY);
  if (g>=1) {
    x->outlet = 1;
    write(x->out, "1", 1);
  }
  if (g<=0) {
    x->outlet = 0;
    write(x->out, "0", 1);
  }
  close(x->out);

  //outlet_float(x->x_obj.ob_outlet, x->outlet);
}

static void *gpio_out_new(t_symbol *nom_arg)
{
  t_gpio_out *x = (t_gpio_out *)pd_new(gpio_out_class);
  x->nom = nom_arg;
  sprintf(x->buf, "/sys/class/gpio/%s/value",x->nom->s_name);
  //outlet_new(&x->x_obj, &s_float);

  return (void *)x;
}

void gpio_out_setup(void) {
  gpio_out_class = class_new(gensym("gpio_out"),
        (t_newmethod)gpio_out_new,
        0, sizeof(t_gpio_out),
        CLASS_DEFAULT,
        A_DEFSYMBOL, 0);

  class_addfloat(gpio_out_class, gpio_out_float);
}

